# Constants

#### MAX\_PROTOCOL\_FEE\_RATIO\_D3 <a href="#max_protocol_fee_ratio_d3" id="max_protocol_fee_ratio_d3"></a>

```solidity
uint8 constant MAX_PROTOCOL_FEE_RATIO_D3 = 0.25e3;
```

#### MAX\_PROTOCOL\_LENDING\_FEE\_RATE\_D18 <a href="#max_protocol_lending_fee_rate_d18" id="max_protocol_lending_fee_rate_d18"></a>

```solidity
uint256 constant MAX_PROTOCOL_LENDING_FEE_RATE_D18 = 0.02e18;
```

#### MAX\_POOL\_FEE\_D18 <a href="#max_pool_fee_d18" id="max_pool_fee_d18"></a>

```solidity
uint64 constant MAX_POOL_FEE_D18 = 0.5e18;
```

#### MIN\_LOOKBACK <a href="#min_lookback" id="min_lookback"></a>

```solidity
uint64 constant MIN_LOOKBACK = 30 minutes;
```

#### MAX\_TICK\_SPACING <a href="#max_tick_spacing" id="max_tick_spacing"></a>

```solidity
uint64 constant MAX_TICK_SPACING = 10_000;
```

#### NUMBER\_OF\_KINDS <a href="#number_of_kinds" id="number_of_kinds"></a>

```solidity
uint8 constant NUMBER_OF_KINDS = 4;
```

#### NUMBER\_OF\_KINDS\_32 <a href="#number_of_kinds_32" id="number_of_kinds_32"></a>

```solidity
int32 constant NUMBER_OF_KINDS_32 = int32(int8(NUMBER_OF_KINDS));
```

#### MAX\_TICK <a href="#max_tick" id="max_tick"></a>

```solidity
uint256 constant MAX_TICK = 322_378;
```

#### MAX\_TICK\_32 <a href="#max_tick_32" id="max_tick_32"></a>

```solidity
int32 constant MAX_TICK_32 = int32(int256(MAX_TICK));
```

#### MIN\_TICK\_32 <a href="#min_tick_32" id="min_tick_32"></a>

```solidity
int32 constant MIN_TICK_32 = int32(-int256(MAX_TICK));
```

#### MAX\_BINS\_TO\_MERGE <a href="#max_bins_to_merge" id="max_bins_to_merge"></a>

```solidity
uint256 constant MAX_BINS_TO_MERGE = 3;
```

#### MINIMUM\_LIQUIDITY <a href="#minimum_liquidity" id="minimum_liquidity"></a>

```solidity
uint128 constant MINIMUM_LIQUIDITY = 1e8;
```

#### MERGED\_LP\_BALANCE\_ADDRESS <a href="#merged_lp_balance_address" id="merged_lp_balance_address"></a>

```solidity
address constant MERGED_LP_BALANCE_ADDRESS = address(0);
```

#### MERGED\_LP\_BALANCE\_SUBACCOUNT <a href="#merged_lp_balance_subaccount" id="merged_lp_balance_subaccount"></a>

```solidity
uint256 constant MERGED_LP_BALANCE_SUBACCOUNT = 0;
```

#### ONE <a href="#one" id="one"></a>

```solidity
uint128 constant ONE = 1e18;
```

#### ONE\_SQUARED <a href="#one_squared" id="one_squared"></a>

```solidity
uint128 constant ONE_SQUARED = 1e36;
```

#### INT256\_ONE <a href="#int256_one" id="int256_one"></a>

```solidity
int256 constant INT256_ONE = 1e18;
```

#### ONE\_D8 <a href="#one_d8" id="one_d8"></a>

```solidity
uint256 constant ONE_D8 = 1e8;
```

#### ONE\_D3 <a href="#one_d3" id="one_d3"></a>

```solidity
uint256 constant ONE_D3 = 1e3;
```

#### INT\_ONE\_D8 <a href="#int_one_d8" id="int_one_d8"></a>

```solidity
int40 constant INT_ONE_D8 = 1e8;
```

#### HALF\_TICK\_D8 <a href="#half_tick_d8" id="half_tick_d8"></a>

```solidity
int40 constant HALF_TICK_D8 = 0.5e8;
```

#### DEFAULT\_DECIMALS <a href="#default_decimals" id="default_decimals"></a>

```solidity
uint8 constant DEFAULT_DECIMALS = 18;
```

#### DEFAULT\_SCALE <a href="#default_scale" id="default_scale"></a>

```solidity
uint256 constant DEFAULT_SCALE = 1;
```

#### EMPTY\_PRICE\_BREAKS <a href="#empty_price_breaks" id="empty_price_breaks"></a>

```solidity
bytes constant EMPTY_PRICE_BREAKS = hex"010000000000000000000000";
```

<br>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mav.xyz/technical-reference/maverick-v2/v2-contracts/maverick-v2-common-contracts/libraries/constants.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
